# calculate the number of layers for a given material 

source("./func/err_FE.R")
d_lay <- 0.0127       # [m]
rho_lay <- 849     #[kg/m]
cp_tot <- 1670       #specific heat capacity [J/(kg*K)]
lambda_lay <- 0.2  #[W/(m*K)]
p_tot <- 12         # Period [h]


#############################################################
#############################################################

A_lay <- 1    # [m]
m_lay <- A_lay * d_lay * rho_lay


c_tot <- cp_tot * m_lay /3600 # why /3600? Parnis 2012 p. 28
r_tot <- d_lay/(lambda_lay * A_lay)

#r_tot <- 0.0004385  # layer resistance [C/W]
#c_tot <- 16968      # capacitance [J/C]

#n_rc <- 12         # number of layers [-]


# calculate number of layers according to Parnis 2012; Transmission matrix of original layer 
# and equivalent layer of homogenous slab, then calculate the error between the elements of the matrices; when error is below 1%,
# the minimum amount of layers is reached


k <- rep(NA, 10000)
n_dum <- seq(1,10000,1)

  for(i in 1:10000){
    
    n_dum2 <- n_dum[i]
    
  k[i] <-  err_FE(n_dum2, r_tot, c_tot, p_tot)   
  
  if(k[i] <= 1){
    
    n_rc <- i
        print(k[i])
    
    break
    
  }  
}

n_rc

