# function that creates a df with seconds values that are interpolated from minute or hourly-based values
# thereby, the minute values are assumed to be valid at each full minute (00:01, 00:02, etc.)


'interpol_sec' <- function(dat_vec){
  
  ntime <- length(dat_vec)
  
  datsec <- data.frame(matrix(data = NA, nrow = how_many_sec, ncol = length(dat_vec)))
  
  emptyvec <- rep(NA, how_many_sec-1)
  
  
  #create matrix with one column for each hour of the year; 
  #first value: taken from Meteonorm, others: "NA"
  
  
  for(i in 1:ntime){
    
    datsec[,i] <- c(dat_vec[i], emptyvec)
    
  }
  
  
  #merge all columns into one vector; by default, the column names are also turned into one vector
  datsec <- gather(datsec)
  
  #just use the vector that includes the hourly values and NA values 
  datsec <- datsec[,2]
  
  #interpolate values with spline approach (polynomic and Runge phenomenon dismission)
  datasec <- na.spline(datsec)
  #datsec <- na.approx(datsec, method = "linear")
  
  return(datsec)

  
  }



#spline <- na.spline(test)
#linear <- na.approx(test)
#lnafor <- na.locf(test)