# ODE LJ05 - residential building (1963)


t_funcODE <- function(t, y, parms) {
  
  Tambi      <- input1(t)
  q_sol_seB  <- input2(t)
  Rl_downB   <- input3(t)
  q_sol_vgsB <- input4(t)
  deltaB     <- input5(t)
  esB        <- input6(t)
  eaB        <- input7(t)
  r_aB       <- input8(t)
  Tair_iK    <- input9(t)
  
  ######
  
  list(c(
    
    #node1:
    (1/(cp_vgs * rho_vgs * d_vgs)) * (q_sol_vgsB
                                      
                                      
                                      - ((1-FF) * emis_lw_VGS * (sigma * y[1]^4 - Rl_downB))                                #(q_IR_VGS_amb)
                                      
                                      - ((sigma*(y[1]^4-y[3]^4))/(((1-emis_lw_VGS)/emis_lw_VGS)+
                                                                    (1/(1-FF))+((1-emis_lw_se)/emis_lw_se)))                # q_IR_VGS_se 
                                      
                                      - 
                                        
                                        (LAI *((cp_air*rho_a)/r_aB)*(y[1]- Tambi))                                          #(q_conv_VGS_amb)
                                      
                                      -  
                                        
                                        ((0.37* (((9.81 * (1/y[2]) * (y[3]-y[2]) * (2*d_ag)^3 )/kin_visc_a^2) +                 # q_conv_vgs_ag
                                                   6.416 * ((u_a * 2 * d_ag)/kin_visc_a)^2)^(0.25)) *                          #(Nusselt number)
                                           (lambda_air/(d_ag *2)) * (y[1]-y[2]))
                                      
                                      - 
                                        
                                        
                                        
                                        ET_fac * ((deltaB*(q_sol_vgsB - ((1-FF) * emis_lw_VGS * (sigma * y[1]^4 - Rl_downB)) -          #latent heat
                                                    (((sigma*(y[1]^4-y[3]^4))/(((1-emis_lw_VGS)/emis_lw_VGS)+               #latent heat
                                                                                 (1/(1-FF))+((1-emis_lw_se)/emis_lw_se))))) #latent heat
                                          + rho_a*cp_air*((esB-eaB)/r_aB))/                                                    #latent heat
                                           (deltaB+ gamma*(1+(r_s/r_aB))))                                                  #latent heat
                                      
    )
    ,
    
    
    #node2:
    
    (1/(cp_air * rho_a * d_ag)) *   
      
      ((0.37 * (                                                                       #Nusselt    #h_conv_vgs_ag      #q_conv_vgs_ag
        ((9.81 * (1/(y[2])) * (y[3]-y[2]) * (2 * d_ag)^3 )/kin_visc_a^2) +      #Grashof     #Nusselt    #h_conv_vgs_ag      #q_conv_vgs_ag              
          6.416 * (                                                            #Nusselt    #h_conv_vgs_ag      #q_conv_vgs_ag
            (u_a * 2 * d_ag)/kin_visc_a)                           #Reynolds      #Nusselt    #h_conv_vgs_ag      #q_conv_vgs_ag
        ^2)^(0.25)) *                                                                  #Nusselt    #h_conv_vgs_ag      #q_conv_vgs_ag
         (lambda_air/(d_ag *2))                                                                    #h_conv_vgs_ag      #q_conv_vgs_ag
       * (y[1] - y[2])                                                                                                 #q_conv_vgs_ag
       
       +                                    
      
      (1.31 * (abs(y[3] - y[2]))^(1/3)) * (y[3]-y[2])),  #q_conv_se_ag
    
    
    #node3: 
    
    (1/(cp_wall1 * rho_w1 * d1/4)) * (q_sol_seB - 
                                      
                                      (FF * emis_lw_se * (sigma * y[3]^4 - Rl_downB))                                 #q_IR_se_amb
                                    
                                    + 
                                      ((sigma*(y[1]^4-y[3]^4))/(((1-emis_lw_VGS)/emis_lw_VGS)+                          #q_IR_VGS_se
                                                                  (1/(1-FF))+((1-emis_lw_se)/emis_lw_se)))
                                    
                                    
                                    -
                                      (1.31 * (abs(y[3] - y[2]))^(1/3)) * (y[3]-y[2])                               #q_conv_se_ag
                                    - 
                                      
                                      (lambda_wall1/(d1/2)* (y[3]-y[4]))),                                           #q_cond
    #node4:
    
    (1/(cp_wall1 * rho_w1 * d1/2)) * (lambda_wall1/(d1/2) * (y[3]-y[4]) - (lambda_wall1/(d1/2) * (y[4]-y[5]))),
    
    #node5:
    #!!!!!!!!!!!!!!!!    
    ((1/(cp_wall1 * rho_w1 * d1/4)) * (lambda_wall1/(d1/2) * (y[4]-y[5]))  -  (1/(cp_wall2 * rho_w2 * d2/4)) * (lambda_wall2/(d2/2)*(y[5]-y[6]))) , 
    #node6:
    
    (1/(cp_wall2 * rho_w2 * d2/2)) * (lambda_wall2/(d2/2) * (y[5]-y[6])  - (lambda_wall2/(d2/2)*(y[6]-y[7]))) ,
    
    #node7:
    #!!!!!!!!!!!!!!!!    
    ((1/(cp_wall2 * rho_w2 * d2/4)) * (lambda_wall2/(d2/2) * (y[6]-y[7]))  -  (1/(cp_wall3 * rho_w3 * d3/14)) * (lambda_wall3/(d3/7)*(y[7]-y[8]))) , 
    
    #node8:
    (1/(cp_wall3 * rho_w3 * d3/7)) * (lambda_wall3/(d3/7) * (y[7]-y[8])  - (lambda_wall3/(d3/7)*(y[8]-y[9]))) ,
    
    #node9:
    (1/(cp_wall3 * rho_w3 * d3/7)) * (lambda_wall3/(d3/7) * (y[8]-y[9])  - (lambda_wall3/(d3/7)*(y[9]-y[10]))) ,
    
    #node10:
    (1/(cp_wall3 * rho_w3 * d3/7)) * (lambda_wall3/(d3/7) * (y[9]-y[10])  - (lambda_wall3/(d3/7)*(y[10]-y[11]))) ,
    
    #node11:
    (1/(cp_wall3 * rho_w3 * d3/7)) * (lambda_wall3/(d3/7) * (y[10]-y[11])  - (lambda_wall3/(d3/7)*(y[11]-y[12]))) ,
    
    #node12:
    (1/(cp_wall3 * rho_w3 * d3/7)) * (lambda_wall3/(d3/7) * (y[11]-y[12])  - (lambda_wall3/(d3/7)*(y[12]-y[13]))) ,
    
    #node13:
    (1/(cp_wall3 * rho_w3 * d3/7)) * (lambda_wall3/(d3/7) * (y[12]-y[13])  - (lambda_wall3/(d3/7)*(y[13]-y[14]))) ,

    #node14:
    #!!!!!!!!!!!!!!!!    
    ((1/(cp_wall3 * rho_w3 * d3/14)) * (lambda_wall3/(d3/7) * (y[13]-y[14]))  -  (1/(cp_wall4 * rho_w4 * d4/92)) * (lambda_wall4/(d4/46)*(y[14]-y[15]))) , 
    
    #node15:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[14]-y[15])  - (lambda_wall4/(d4/46)*(y[15]-y[16]))) ,

    #node16:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[15]-y[16])  - (lambda_wall4/(d4/46)*(y[16]-y[17]))) ,
    
    #node17:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[16]-y[17])  - (lambda_wall4/(d4/46)*(y[17]-y[18]))) ,
    
    #node18:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[17]-y[18])  - (lambda_wall4/(d4/46)*(y[18]-y[19]))) ,
    
    #node19:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[18]-y[19])  - (lambda_wall4/(d4/46)*(y[19]-y[20]))) ,
    
    #node20:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[19]-y[20])  - (lambda_wall4/(d4/46)*(y[20]-y[21]))) ,
    
    #node21:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[20]-y[21])  - (lambda_wall4/(d4/46)*(y[21]-y[22]))) ,
    
    #node22:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[21]-y[22])  - (lambda_wall4/(d4/46)*(y[22]-y[23]))) ,
    
    #node23:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[22]-y[23])  - (lambda_wall4/(d4/46)*(y[23]-y[24]))) ,
    
    #node24:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[23]-y[24])  - (lambda_wall4/(d4/46)*(y[24]-y[25]))) ,
    
    #node25:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[24]-y[25])  - (lambda_wall4/(d4/46)*(y[25]-y[26]))) ,
    
    #node26:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[25]-y[26])  - (lambda_wall4/(d4/46)*(y[26]-y[27]))) ,
    
    #node27:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[26]-y[27])  - (lambda_wall4/(d4/46)*(y[27]-y[28]))) ,
    
    #node28:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[27]-y[28])  - (lambda_wall4/(d4/46)*(y[28]-y[29]))) ,
    
    #node29:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[28]-y[29])  - (lambda_wall4/(d4/46)*(y[29]-y[30]))) ,
    
    #node46:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[29]-y[30])  - (lambda_wall4/(d4/46)*(y[30]-y[31]))) ,
    
    #node31:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[30]-y[31])  - (lambda_wall4/(d4/46)*(y[31]-y[32]))) ,
    
    #node32:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[31]-y[32])  - (lambda_wall4/(d4/46)*(y[32]-y[33]))) ,
    
    #node33:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[32]-y[33])  - (lambda_wall4/(d4/46)*(y[33]-y[34]))) ,
    
    #node34:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[33]-y[34])  - (lambda_wall4/(d4/46)*(y[34]-y[35]))) ,
    
    #node35:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[34]-y[35])  - (lambda_wall4/(d4/46)*(y[35]-y[36]))) ,
    
    #node36:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[35]-y[36])  - (lambda_wall4/(d4/46)*(y[36]-y[37]))) ,
    
    #node37:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[36]-y[37])  - (lambda_wall4/(d4/46)*(y[37]-y[38]))) ,
    
    #node38:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[37]-y[38])  - (lambda_wall4/(d4/46)*(y[38]-y[39]))) ,
    
    #node39:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[38]-y[39])  - (lambda_wall4/(d4/46)*(y[39]-y[40]))) ,
    
    #node40:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[39]-y[40])  - (lambda_wall4/(d4/46)*(y[40]-y[41]))) ,
    
    #node41:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[40]-y[41])  - (lambda_wall4/(d4/46)*(y[41]-y[42]))) ,
    
    #node42:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[41]-y[42])  - (lambda_wall4/(d4/46)*(y[42]-y[43]))) ,
    
    #node43:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[42]-y[43])  - (lambda_wall4/(d4/46)*(y[43]-y[44]))) ,
    
    #node44:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[43]-y[44])  - (lambda_wall4/(d4/46)*(y[44]-y[45]))) ,
    
    #node45:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[44]-y[45])  - (lambda_wall4/(d4/46)*(y[45]-y[46]))) ,
    
    #node46:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[45]-y[46])  - (lambda_wall4/(d4/46)*(y[46]-y[47]))) ,
    
    #node47:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[46]-y[47])  - (lambda_wall4/(d4/46)*(y[47]-y[48]))) ,
    
    #node48:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[47]-y[48])  - (lambda_wall4/(d4/46)*(y[48]-y[49]))) ,
    
    #node49:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[48]-y[49])  - (lambda_wall4/(d4/46)*(y[49]-y[50]))) ,
    
    #node50:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[49]-y[50])  - (lambda_wall4/(d4/46)*(y[50]-y[51]))) ,
    
    #node51:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[50]-y[51])  - (lambda_wall4/(d4/46)*(y[51]-y[52]))) ,
    
    #node52:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[51]-y[52])  - (lambda_wall4/(d4/46)*(y[52]-y[53]))) ,
    
    #node53:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[52]-y[53])  - (lambda_wall4/(d4/46)*(y[53]-y[54]))) ,
    
    #node54:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[53]-y[54])  - (lambda_wall4/(d4/46)*(y[54]-y[55]))) ,
    
    #node55:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[54]-y[55])  - (lambda_wall4/(d4/46)*(y[55]-y[56]))) ,
    
    #node56:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[55]-y[56])  - (lambda_wall4/(d4/46)*(y[56]-y[57]))) ,
    
    #node57:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[56]-y[57])  - (lambda_wall4/(d4/46)*(y[57]-y[58]))) ,
    
    #node58:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[57]-y[58])  - (lambda_wall4/(d4/46)*(y[58]-y[59]))) ,
    
    #node59:
    (1/(cp_wall4 * rho_w4 * d4/46)) * (lambda_wall4/(d4/46) * (y[58]-y[59])  - (lambda_wall4/(d4/46)*(y[59]-y[60]))) ,

    #node60:
    #!!!!!!!!!!!!!!!!    
    ((1/(cp_wall4 * rho_w4 * d4/92)) * (lambda_wall4/(d4/46) * (y[59]-y[60]))  -  (1/(cp_wall5 * rho_w5 * d5/4)) * (lambda_wall5/(d5/2)*(y[60]-y[61]))) , 
    
    #node61:
    (1/(cp_wall5 * rho_w5 * d5/2)) * (lambda_wall5/(d5/2) * (y[60]-y[61])  - (lambda_wall5/(d5/2)*(y[61]-y[62]))) ,
    
    #node62:
    (1/(cp_wall5 * rho_w5 * d5/4)) * (lambda_wall5/(d5/2) * (y[61]-y[62])  - h_conv_si *(y[62]-Tair_iK))
    
     
        
      )
  
  )
  
}
